% Programma principale da far partire quando inizia la simulazione 
clear
% Definizione di tutte le costanti
N=15; % Dimensione della Rete UWB
M=30; % N max di comunicazioni contemporanee attive in un nodo
R=10; % Raggio della cella UWB
SINR_RIF_QoS= 25.1188643151; % 14db
SINR_RIF_BE= 15.84893192461; % 12db
DELTA= 1.5849; % 2db -  il margine da aggiungere, sul singolo setup, al SINR_RIF
%DELTA= 2.5119; % 4db -  il margine da aggiungere, sul singolo setup, al SINR_RIF
mp2=3.05e-20;
o2=6.045e-30;
N0mp=7.2336e-31;
Ew=1.079e-10;
Plim=12e-3; % Potenza max. uscente dal nodo (vedi limite FCC)
Psegn=6e-3;
%Pnmax=30e-3;
Pnmax=6e-3;%Valore originale
Rmin=10e3; % Rate minimo per tx di tipo BE
PAR_ALFA=1; % Vedi riadattamento rate al rx
% Definizione delle variabili da mettere come INPUT
%N_utenti=input('Inserire il n. di utenti presenti nella rete: ');
multi=input('Digitare 0 per simulazione single-hop, altrimenti 1 per simulazione multi-hop: ');
if multi==1
   distanza_parametrica=input('Inserire la distanza minima in metri per effettuare il multi-hop (0..9): ');
   %Per esempio se digiti 5 solo al di sopra dei 5m si fa multi-hop
else
   distanza_parametrica=20;
end
timer_comunicazione=input('Inserire la durata di una comunicazione(in sec.): ');
timer_simulazione=input('Inserire la durata della simulazione(in sec.): ');
prob_BE=input('Inserire la probabilit di traffico BE(0..100): ');
% Inizializzazione delle altre variabili
app3=0;
app4=1;
%data=zeros((timer_simulazione*4),3);
MH=0;
reteapp=zeros(N,N,M,14);
reteapp2=zeros(N,N,M,14);
bug_flavio=0;
cont_MH_non_riusciti_per_assenza_nodo=0;
abilita_protocollo=1;
cont_richieste_tot_BE=0;
cont_richieste_tot_QoS=0;
cont_richieste_tot_QoS_MH=0;
cont_richieste_tot_BE_MH=0;
cont_richieste_accettate_BE=0;
cont_richieste_accettate_BE_MH=0;
cont_richieste_accettate_QoS=0;
cont_richieste_accettate_QoS_MH=0;
cont_richieste_terminate_BE=0;
cont_tx_BE_appese=0;
cont_pacchetti_segn=0;
cont_pacchetti_dati=0;
cont_tempo=0;
cont_funz_protocollo_QoS_caso1=0;
cont_funz_protocollo_QoS_caso2=0;
cont_funz_protocollo_QoS_caso3=0;
cont_funz_protocollo_QoS_caso4=0;
cont_funz_protocollo_BE_caso1=0;
cont_funz_protocollo_BE_caso2=0;
cont_funz_protocollo_BE_caso3=0;
cont_funz_protocollo_BE_caso4=0;
nodo1=0;
nodo2=0;
nodo3=0;
nodo4=0;

% Creazione della matrice "Ambiente"
crea_ambiente_unif;
%crea_ambiente;

% Inizio della simulazione
while cont_tempo < timer_simulazione
   bug_flavio=0;
   % Hp che ogni secondo avvenga una richiesta di instaurazione di un nuovo setup
   % Instaurazione del singolo setup
   % Scelta del nodo tx all'interno della rete
   scelta_nodo_tx;
   % Inserimento del tipo di tx(BE-QoS)
   rete(x,y,z,5)=tipo_di_trasmissione(prob_BE);
   if rete(x,y,z,5)==1
      cont_richieste_tot_QoS=cont_richieste_tot_QoS+1;
   else cont_richieste_tot_BE=cont_richieste_tot_BE+1;
   end
   %Procedura delta_need
   delta_need;
   %Scelta del nodo rx all'interno della rete
   scelta_nodo_rx;
   % Calcolo dell'interferenza Ij
   cont_pacchetti_segn=cont_pacchetti_segn+2; % pacchetto RTS + pacchetto MAX_POT
   rete(a,b,w,9)=interferenza(rete,a,b,x,y);
   cont_pacchetti_segn=cont_pacchetti_segn+1; % pacchetto ACK_RTS
   % Calcolo del rate della tx
   rete(x,y,z,8)=calcolo_rate(rete(x,y,z,5));
   rete(a,b,w,8)=rete(x,y,z,8);
   % Calcolo della potenza Pc
   app=0;
   for app2=1:M % Controllo se il nodo tx sta gi erogando potenza verso qualche altro nodo
      if rete(x,y,app2,1)==2
         app=app+rete(x,y,app2,7);
      end   
   end
   Pc=Pnmax-app;
   % Calcolo della potenza Pij
   if rete(x,y,z,5)==1
      Pij=(SINR_RIF_QoS*DELTA*(N0mp*Ew+o2*rete(a,b,w,9))*rete(x,y,z,8))/(guadagno(x,y,a,b)*mp2);
   else Pij=(SINR_RIF_BE*DELTA*(N0mp*Ew+o2*rete(a,b,w,9))*rete(x,y,z,8))/(guadagno(x,y,a,b)*mp2);
   end
   rete(x,y,z,7)=Pij;
   rete(a,b,w,7)=Pij;
   fprintf('\n');
   fprintf('********************************************\n');
   fprintf('Richiesta numero    %d\n',cont_tempo);
   fprintf('Richiesta di collegamento del nodo %d %d con il nodo %d %d \n',x,y,a,b);
   fprintf('Tipo di trasmissione%d\n',rete(x,y,z,5));
   fprintf('Bit Rate               %g\n',rete(x,y,z,8));
   fprintf('Potenza richiesta   %g\n',Pij);
   fprintf('Potenza Pv           %g\n',Pv);
   
   scelta_protocollo;
      
   %grafico;   
   cont_tempo=cont_tempo+1;
   
     
     % Misura della potenza in aria
     misura_potenza;   
     % Abbattimento delle tx "finite" nel nuovo valore di cont_tempo
     % NB: Prima decremento il timer_comunicazione, poi eventualmente abbatto la comunicazione!!!
     for k=1:N
        for h=1:N
           if rete(k,h)~=0 & rete(k,h)~=-1
              for m=1:M
                 if rete(k,h,m,6)~=0
                    rete(k,h,m,6)=rete(k,h,m,6)-1;
                    if rete(k,h,m,6)==0 % La comunicazione  finita!!
                       if rete(k,h,m,5)==2
                          cont_richieste_terminate_BE=cont_richieste_terminate_BE+1;
                       end
                       rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0];
                       rete(k,h,m,:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0];
                    end
                 end
              end
           end
        end
     end
  end % E' finita la simulazione, il contatore "cont_tempo"  diventato = a "timer_simulazione"
  % Ora per devo aggiornare il cont_tx_BE_appese, in quanto ci sono delle tx BE
  % che sono ancora attive, e non sono ancora terminate
  for k=1:N
     for h=1:N
        if rete(k,h)~=0 & rete(k,h)~=-1
           for m=1:M
              if rete(k,h,m,6)~=0 & rete(k,h,m,5)==2
                 cont_tx_BE_appese=cont_tx_BE_appese+1;
              end
           end
        end
     end
  end
  
 % Definizione delle variabili da mettere come OUTPUT
 fprintf('********************************************\n');
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 fprintf('Richieste totali QoS : %g di cui con MH: %g\n',cont_richieste_tot_QoS,cont_richieste_tot_QoS_MH);
 fprintf('Richieste totali QoS MH: %g\n',cont_richieste_tot_QoS_MH);
 fprintf('Richieste accettate QoS: %g di cui con MH %g\n',cont_richieste_accettate_QoS,cont_richieste_accettate_QoS_MH);
 fprintf('Richieste accettate QoS MH: %g\n',cont_richieste_accettate_QoS_MH);
 if cont_richieste_tot_QoS~=0
    fprintf('Percentuale richieste accettate QoS: %g\n',cont_richieste_accettate_QoS/cont_richieste_tot_QoS*100);
    fprintf('Percentuale richieste accettate QoS MH sul totale: %g\n',cont_richieste_accettate_QoS_MH/cont_richieste_tot_QoS*100);
 end
 if cont_richieste_tot_QoS_MH~=0
    fprintf('Percentuale richieste accettate QoS MH sul multihop: %g\n',cont_richieste_accettate_QoS_MH/cont_richieste_tot_QoS_MH*100);
 end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 fprintf('Richieste totali BE: %g di cui con MH: %g\n',cont_richieste_tot_BE,cont_richieste_tot_BE_MH);
 fprintf('Richieste totali BE MH: %g\n',cont_richieste_tot_BE_MH);
 fprintf('Richieste accettate BE: %g\n',cont_richieste_accettate_BE);
 fprintf('Richieste accettate BE MH: %g\n',cont_richieste_accettate_BE_MH);
 if cont_richieste_tot_BE~=0
    fprintf('Percentuale richieste accettate BE: %g\n',cont_richieste_accettate_BE/cont_richieste_tot_BE*100);
    fprintf('Percentuale richieste accettate BE MH sul totale: %g\n',cont_richieste_accettate_BE_MH/cont_richieste_tot_BE*100);
 end
 if cont_richieste_tot_BE_MH~=0
    fprintf('Percentuale richieste accettate BE MH sul multihop: %g\n',cont_richieste_accettate_BE_MH/cont_richieste_tot_BE_MH*100);
 end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 fprintf('Tramissioni in MH non partite per assenza nodo: %g\n',cont_MH_non_riusciti_per_assenza_nodo);
 fprintf('Trasmissioni BE terminate: %g\n',cont_richieste_terminate_BE);
 fprintf('Trasmissioni BE attualmente attive: %g\n',cont_tx_BE_appese);
 fprintf('Trasmissioni QoS partite senza il protocollo: %g\n',cont_funz_protocollo_QoS_caso1);
 fprintf('Trasmissioni QoS partite con riadattamento al cluster: %g\n',cont_funz_protocollo_QoS_caso2);
 fprintf('Trasmissioni QoS partite con riadattamento al nodo: %g\n',cont_funz_protocollo_QoS_caso3);
 fprintf('Trasmissioni QoS partite con riadattamento al cluster e al nodo: %g\n',cont_funz_protocollo_QoS_caso4);
 fprintf('Trasmissioni BE partite senza il protocollo: %g\n',cont_funz_protocollo_BE_caso1);
 fprintf('Trasmissioni BE partite con riadattamento al cluster: %g\n',cont_funz_protocollo_BE_caso2);
 fprintf('Trasmissioni BE partite con riadattamento al nodo: %g\n',cont_funz_protocollo_BE_caso3);
 fprintf('Trasmissioni BE partite con riadattamento al cluster e al nodo: %g\n',cont_funz_protocollo_BE_caso4);
 fprintf('Valore max. di potenza in aria misurata dalla centralina 1: %g\n',nodo1);
 fprintf('Valore max. di potenza in aria misurata dalla centralina 2: %g\n',nodo2);
 fprintf('Valore max. di potenza in aria misurata dalla centralina 3: %g\n',nodo3);
 fprintf('Valore max. di potenza in aria misurata dalla centralina 4: %g\n',nodo4);
 
 %grafico2;
 grafico3;
 %inter;
 
 
 
 