function reteout = Riadattxqos (rete,x,y,z,FLAG,Pij);

N=15; % Dimensione della Rete UWB
M=30; % N max di comunicazioni contemporanee attive in un nodo
R=10; % Raggio della cella UWB
SINR_RIF_QoS= 25.1188643151; % 14db
SINR_RIF_BE= 15.84893192461; % 12db
DELTA= 1.584893192461; % 2db -  il margine da aggiungere, sul singolo setup, al SINR_RIF
mp2=3.05e-20;
o2=6.045e-30;
N0mp=7.2336e-31;
Ew=1.079e-10;
%Plim=12e-3; % Potenza max. uscente dal nodo (vedi limite FCC)
%Psegn=6e-3;
%Pnmax=6e-3;
Rmin=10e3; % Rate minimo per tx di tipo BE
%PAR_ALFA=1; % Vedi riadattamento rate al rx


for k=max(1,x-R):min(N,x+R)
	for h=max(1,y-R):min(N,y+R)
		if (rete(k,h)==1 | rete(k,h)==2 | rete(k,h)==3) & distanza(k,h,x,y)<=R & distanza(k,h,x,y)~=0
			for m=1:M
				if rete(k,h,m,1)==3 & (rete(k,h,m,2)~=x | rete(k,h,m,3)~=y)
				% Procedura riadattamento rate al tx
					if rete(k,h,m,5)==2 & rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)~=2
						if rete(k,h,m,10)<Pij & rete(k,h,m,10)<FLAG
                     Rtrl=(rete(k,h,m,7)*guadagno(rete(k,h,m,2),rete(k,h,m,3),k,h)*mp2)/(SINR_RIF_BE*DELTA*((rete(x,y,z,7)*guadagno(x,y,k,h)*o2)+(N0mp*Ew+o2*rete(k,h,m,9))));
                     if Rtrl>=Rmin % Allora assegno il nuovo rate alla tx Trl-l
								rete(k,h,m,8)=Rtrl;
                        rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),8)=Rtrl;
                        if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==3
                           Txk=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),12);
                           Txh=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),13);
                           Txm=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),14);
                           rete(Txk,Txh,Txm,8)=Rtrl;
                           rete(rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),rete(Txk,Txh,Txm,4),8)=Rtrl;
                        end
                           if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==0
                              fprintf('Ho cambiato il rate alla tx BE tra %d %d e %d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Rtrl);
                           else
                              fprintf('Ho cambiato il rate alla tx BE MH tra %d %d-->%d %d e %d %d-->%d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Txk,Txh,rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),Rtrl);
                           end
                     else
                        if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==0
                           fprintf('Ho abbattuto la tx BE tra %d %d e %d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Rtrl);
                        else
                           %fprintf('Ho abbattuto la tx BE MH tra %d %d-->%d %d e %d %d-->%d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Txk,Txh,rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),Rtrl);
                        end
                        if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==1
                           Txk=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),12);
                           Txh=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),13);
                           Txm=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),14);
                           rete(rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),rete(Txk,Txh,Txm,4),:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0];
                           rete(Txk,Txh,Txm,:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0];
                        end
                        rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0]; % Abbatto la tx (BE) Trl-l
                        rete(k,h,m,:)=[1,0,0,0,0,0,0,0,0,0,0,0,0,0];
                     end
						else if rete(k,h,m,10)<Pij & rete(k,h,m,10)>=FLAG
								Rtrl=(rete(k,h,m,7)*guadagno(rete(k,h,m,2),rete(k,h,m,3),k,h)*mp2)/(SINR_RIF_BE*DELTA*((rete(x,y,z,7)*guadagno(x,y,k,h)*o2)+(N0mp*Ew+o2*rete(k,h,m,9))));
								if Rtrl>=Rmin % Allora assegno il nuovo rate alla tx Trl-l
									rete(k,h,m,8)=Rtrl;
                           rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),8)=Rtrl;
                           if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==1
                              Txk=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),12);
                              Txh=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),13);
                              Txm=rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),14);
                              rete(Txk,Txh,Txm,8)=Rtrl;
                              rete(rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),rete(Txk,Txh,Txm,4),8)=Rtrl;
                           end
                           if rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==0
                              fprintf('Ho cambiato il rate alla tx BE tra %d %d e %d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Rtrl);
                           elseif rete(rete(k,h,m,2),rete(k,h,m,3),rete(k,h,m,4),11)==1
                              fprintf('Ho cambiato il rate alla tx BE MH tra %d %d-->%d %d e %d %d-->%d %d portandola a %g\n',rete(k,h,m,2),rete(k,h,m,3),k,h,Txk,Txh,rete(Txk,Txh,Txm,2),rete(Txk,Txh,Txm,3),Rtrl);
                           end
                        end % Cio se Rtrl<Rmin non tocco nulla, lascio invariato il rate!!
                     end
                  end
               end% Fine procedura riadattamento rate al tx
				end
			end
		end
	end
end
reteout=rete;